#!/usr/bin/perl

## LYNX Theme - Dpto Allconnections World Wide Web Ibercom
##
## theme.pl
## Aqui se controla el contenido que sale cuando nos metemos
## en el cualquier modulo. Cuando estamos en un indice de modulos
## o en el indice de familia (red, servidores, etc .. ) se tira de index.cgi
##
## Pello Xabier Altadill Izura - pello.altadill@ibercom.com
## pello@pello.info
##
## Updates at www.pello.info

#theme_prebody - invocado antes del cuerpo del modulo concreto
#theme_postbody - invocado despues del cuerpo del modulo concreto
#theme_header - Cabecera: realmente aqui esta todo el mogollon, puesto que es lo que imprime casi todo menos el cuerpo del modulo
#theme_footer - invocado en lugar de la funcion footer con los mismos parametros
#theme_error - invocado en lugar de la funcion de error con los mismos parametros


# Establecemos el OS y su version
$os_type = $gconfig{'real_os_type'} ? $gconfig{'real_os_type'}
                      : $gconfig{'os_type'};

$os_version = $gconfig{'real_os_version'} ? $gconfig{'real_os_version'}
                            : $gconfig{'os_version'};


## theme_header
# Con esto escribimos la cabecera del theme
sub theme_header {

local @available = ("allconnections","webmin", "system", "servers", "net", "mantenimiento");

local $ll;
local %access = &get_module_acl();
local %gaccess = &get_module_acl(undef, "");

local $categoria_actual = (defined($in{cat})?$in{cat}:$module_info{category});
local $modulo_actual = $module_info{name};


# AQUI EMPIEZA EL HTML
print "<!doctype html public \"-//W3C//DTD HTML 3.2 Final//EN\">\n";
print "<html>\n";



# Escribimos la cabecera HEAD
print "<head>\n";
if ($charset) {
    print "<meta http-equiv=\"Content-Type\" ",
          "content=\"text/html; Charset=$charset\">\n";
}

# Titulo de la pagina
if (@_ > 0) {
    if ($gconfig{'sysinfo'} == 1) {
        printf "<title>%s v%s - %s -> /%s/%s</title>\n",$os_type, $os_version, &get_system_hostname(),$categoria_actual,$modulo_actual;
    } elsif ($gconfig{'sysinfo'} == 4) {
        printf "<title>%s v%s - %s -> /%s/%s</title>\n",$os_type, $os_version, &get_system_hostname(),$categoria_actual,$modulo_actual;
    } else {
        print "<title>Webmin $os_type v$os_version - ".&get_system_hostname()." -&gt; /$categoria_actual/$modulo_actual</title>\n";
    }

    # Barra de estado de Allconnections
    print $_[7] if ($_[7]);
    if ($gconfig{'sysinfo'} == 0 && $remote_user) {
        print "<SCRIPT LANGUAGE=\"JavaScript\">\n";
        printf "defaultStatus=\"%s v%s - %s /%s/%s\";\n", $os_type, $os_version , &get_system_hostname(),$categoria_actual,$modulo_actual;
        print "</SCRIPT>\n";
    }
}


@msc_modules = &get_available_module_infos()
	if (!defined(@msc_modules));

# Terminamos la cabecera
#### REFERENCIAMOS LA HOJA DE ESTILO ################
print qq~<link href="/lynxth/lynx.css" rel="stylesheet" type="text/css" />~;
print "</head>\n";

## Pinta la primera linea del cuerpo de HTML
if ($theme_no_table) {
	print '<body bgcolor="#000000" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" '.$_[8].'>';
} else {
	print '<body bgcolor="#000000" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" '.$_[8].'>';
}

## TABLA Superior: icono, enlace de ayuda etc.
if ($remote_user && @_ > 1) {

	# Mostramos informacion basica con el enlace a allconnections y a la ayuda
	local $logout = $main::session_id ? "/session_login.cgi?logout=1"
					  : "/switch_user.cgi";
	local $loicon = $main::session_id ? "logout.jpg" : "switch.jpg";
	local $lowidth = $main::session_id ? 84 : 27;
	local $lotext = $main::session_id ? $text{'main_logout'}
					  : $text{'main_switch'};

	# Pintamos la tabla inicial con el logotipo, etc
	print qq~<table width="100%" border=0 cellspacing="0" cellpadding="0"  height="32">
	  <tr>
	    <td width="4" nowrap></td>
	    <td width="25%" nowrap>
		<a href="http://www.webmin.com">
		WEBMIN
		</a>
		</td><td>
		<a href="http://www.pello.info">
		Lynx Theme - Pello Altadill
		</a></td><td width="20%"></td>~;

	## Aqui metemos el LOGOUT y el FEEDBACK
	if (!$ENV{'ANONYMOUS_USER'}) {
		if ($gconfig{'nofeedbackcc'} != 2 && $gaccess{'feedback'}) {
			print qq~<td><a href='/feedback_form.cgi?module=$module_name'>Feedback</a></td>~;
			}
		if (!$ENV{'SSL_USER'} && !$ENV{'LOCAL_USER'} &&
		    !$ENV{'HTTP_WEBMIN_SERVERS'}) {
			## aqui un espacio en blanco
			if ($gconfig{'nofeedbackcc'} != 2 &&
			    $gaccess{'feedback'}) {
				print qq~<td>&nbsp;&nbsp;</td>~;
				}
			print qq~<td width="84" nowrap><a href='$logout'>Logout</a></td>~;
			}
		}


	# Cerramos la tabla
        print qq~<td width="3" nowrap></td></tr></table>~;

}# endif



local $one = @msc_modules == 1 && $gconfig{'gotoone'};
local $notabs = $gconfig{"notabs_${base_remote_user}"} == 2 || $gconfig{"notabs_${base_remote_user}"} == 0 && $gconfig{'notabs'};


###### BARRA de iconos de CATEGORIAS ###############
if (@_ > 1 && !$one && $remote_user && !$notabs) { # if-primigenio

    # Mostrar por pantalla categorias de los modulos (sistema, red, servidores,..)
   ## Ahora sacamos la relacion categorias/modulos
    local %catnames;
    &read_file("$config_directory/webmin.catnames", \%catnames);
    foreach $m (@msc_modules) {
        local $c = $m->{'category'};
        next if ($cats{$c});
        if (defined($catnames{$c})) {
            $cats{$c} = $catnames{$c};
        } elsif ($text{"category_$c"}) {
            $cats{$c} = $text{"category_$c"};
        } else {
            # Intentar tomar el nombre de categoria a partir del modulo
            local %mtext = &load_language($m->{'dir'});
            if ($mtext{"category_$c"}) {
                $cats{$c} = $mtext{"category_$c"};
            } else {
                $c = $m->{'category'} = "";
                $cats{$c} = $text{"category_$c"};
            }
        }#endif
    }# end foreach

  
    @cats = sort { $b cmp $a } keys %cats;
    $cats = @cats;
    $per = $cats ? 100.0 / $cats : 100;

    if ($theme_index_page) {
	    # si no se especifica ningun catalogo...
	    if (!defined($in{'cat'})) {
	       
		# Usar la categoria por defecto
		if (defined($gconfig{'deftab'}) &&
		    &indexof($gconfig{'deftab'}, @cats) >= 0) {
		    $in{'cat'} = $gconfig{'deftab'};
		} else {
		    $in{'cat'} = $cats[0];
		}
	   } elsif (!$cats{$in{'cat'}}) {
		$in{'cat'} = "";	
	   }
    }


########### Inicio de la menu de navegacion DE CATEGORIAS y MODULOS de la izquierda

	print qq~<table width="100%" border=0 cellspacing="0" cellpadding="0">
	<tr><td valign="top">
	<table border=0  cellspacing="0" cellpadding="0"><tr>~;

# Por cada catalogo
    
  foreach $c (@cats) {
	local $t = $cats{$c};
        $inlist    = "false";
           foreach $testet (@available) {
               if ($testet eq $c) {
                $inlist = "true";
               } 
           } #endfor

	## Aqui mostramos el titulo #####
	print qq~<td><A HREF="/?cat=$c">$t</a>&nbsp;|&nbsp;</td>~;

 }# End foreach: termina el listado de categorias


    print qq~<td width="100%" nowrap>&nbsp;</td>
  </tr>
	</td>
	</tr>
	</table>
	</td></tr><tr>
	<td valign="top" width="100%"><hr size=1>~;

####################### INICIO DE CELDA CENTRAL ##############################

} # endif-primigenio




## SUBMENU ESPECIAL DE MODULOS: AYUDA contextual, indice de modulo.

if (@_ > 1 && (!$_[5] || $ENV{'HTTP_WEBMIN_SERVERS'})) {

   # Mostrar tabulaciones bajo categorias de mdulos
   # Esto es el inicio de la tabla de pestaas especiales
	print qq~<table width="100%" border=0 cellspacing="0" cellpadding="0"><tr>~;

   # sacamos informacion de usuario conectado
   if ($gconfig{'sysinfo'} == 2 && $remote_user) {
	printf "%s%s logged into %s %s on %s (%s%s)</td>\n",
		$ENV{'ANONYMOUS_USER'} ? "Anonymous user" : "<tt>$remote_user</tt>",
		$ENV{'SSL_USER'} ? " (SSL certified)" :
		$ENV{'LOCAL_USER'} ? " (Local user)" : "",
		$text{'programname'},
		$version, "<tt>".&get_system_hostname()."</tt>",
		$os_type, $os_version eq "*" ? "" : " $os_version";
	}

	if ($ENV{'HTTP_WEBMIN_SERVERS'}) {
		print "&nbsp;&nbsp;<a href='$ENV{'HTTP_WEBMIN_SERVERS'}'>",
	      	"$text{'header_servers'}</a>&nbsp;&nbsp;|<br>\n";
   	}
	
   	if ($notabs && !$_[5]) { 
		print "&nbsp;&nbsp;<a href='$gconfig{'webprefix'}/?cat=$module_info{'category'}'>$text{'header_webmin'}</a>&nbsp;&nbsp;|<br>\n";
	}

	if (!$_[4]) {
		local $mi = $module_index_link ||
			    $module_name ? "/$module_name/" : "/";
		print "&nbsp;&nbsp;<a href=\"$gconfig{'webprefix'}$mi\">",
			    "$text{'header_module'}</a>&nbsp;&nbsp;|"; 
	}

	if (ref($_[2]) eq "ARRAY" && !$ENV{'ANONYMOUS_USER'}) {
		print "&nbsp;&nbsp;".&hlink($text{'header_help'}, $_[2]->[0], $_[2]->[1])."&nbsp;&nbsp;|"; 
		}

	# PESTAA: Opcion de ayuda de modulo
	elsif (defined($_[2]) && !$ENV{'ANONYMOUS_USER'}) {
		print "&nbsp;&nbsp;".&hlink($text{'header_help'}, $_[2])."&nbsp;&nbsp;|"; 
		}

	# PESTAA: Opcion de configurar el modulo
	if ($_[3]) {
		if (!$access{'noconfig'}) {
			print "&nbsp;&nbsp;<a href=\"/config.cgi?$module_name\">",
			      $text{'header_config'},"</a>&nbsp;&nbsp;|"; 
			}
		}

    local $t;

    # PESTAA: las restantes
    # Aqui van el resto de pestaas restantes
    # Aqui se muestra la de Autor por ejemplo
    foreach $t (split(/<br>/, $_[6])) {
      if ($t =~ /\S/) {
		print "&nbsp;&nbsp;$t &nbsp;&nbsp;|"; 
      }
    }

# Metemos la ultima celda del menu especial de modulos 

print qq~
    <td nowrap width="100%" valign="top">

      <table width="100%" border=0 cellspacing="0" cellpadding="0">
        <tr>
          <td></td>
        </tr>
      </table>

    </td>
  </tr>
</table>~;
# Fin de la tabla lateral

    if (!$_[5]) {
	    # Show page title in tab
	    local $title = $_[0];
	    $title =~ s/&auml;//g;
	    $title =~ s/&ouml;//g;
	    $title =~ s/&uuml;//g;
	    $title =~ s/&nbsp;/ /g;

	    ## TITULO del modulo
	    print "<p><table border=0 cellpadding=0 cellspacing=0 width=95% align=center><tr><td align='center'><table border=0 cellpadding=0 cellspacing=0 height=20><tr>\n";
	    print "<td align='center'>&nbsp;<font size='+1'><b>$title</b></font>&nbsp;<br>\n";
		## version del modulo o programa    
		if ($_[9]) {
			print "&nbsp;($_[9])&nbsp;\n";
		}
		
	    print "</td>";

	    print "</tr></table></td></tr></table>"; 

	     &theme_prebody;
	}
 } elsif (@_ > 1) {
	    print qq~<table width="100%" border=0 cellspacing="0" cellpadding="0">
	  <tr>
	    <td width="100%" nowrap></td>
	  </tr>
	</table><br>~;
 }
@header_arguments = @_;


}

## theme_prebody
# Con esto escribimos la parte anterior al body del modulo concreto.
# ciudado, no se refiere al body de la pagina entera
sub theme_prebody
{
if ($theme_no_table) {
	print "<ul>\n";
	}
else {
	#print "<table border=0 width=95% align=center cellspacing=0 cellpadding=0><tr><td>\n";
	print "<table border=0 width=95% align=center cellspacing=0 cellpadding=0><tr><td>\n";
	# esto puede ser el titular del modulo
	print "<table border=0 width=95% align=center cellspacing=0 cellpadding=0><tr><td>\n";
	}
}

## theme_footer
# Con esto aadimos la parte inferior del cuerpo del modulo
sub theme_footer {
local $i;

if ($theme_no_table) {
	print "</ul>\n";
	}
elsif (@header_arguments > 1 && !$header_arguments[5]) {
	print "</table></table><br>\n";
	}

print "<table border='0' width=100% cellspacing=0 cellpadding=0><tr><td align=center>\n";

for($i=0; $i+1<@_; $i+=2) {
    local $url = $_[$i];
    if ($url eq '/') {
        $url = "/?cat=$module_info{'category'}";
        }
    elsif ($url eq '' && $module_name) {
        $url = "/$module_name/";
        }
    elsif ($url =~ /^\?/ && $module_name) {
        $url = "/$module_name/$url";
        }
    if ($i == 0) {
	## Esto es la flecha de regresa
        print "&nbsp;<a href=\"$url\">&lt;back</a>\n";
        }
    else {
        print "&nbsp;|\n";
        }
    print "&nbsp;<a href=\"$url\">",&text('main_return', $_[$i+1]),"</a>\n";
    }
print "</td></tr></table>\n";

####################### FIN DE CELDA CENTRAL ##############################
print qq~</td></tr></table>~;

##### tabla final ############################
    print "<table width=95% align=center border=0><tr><td width=100%><b><font>&nbsp;&nbsp;";
    print &text('main_version', $os_version, $hostname, $os_type)

        if (!$gconfig{'nohostname'});
    print "</font></b>\n";
    print "</td>\n";

print "</tr></table>\n";


print "<br>\n";
if (!$_[$i]) {
    if (defined(&theme_postbody)) {
        &theme_postbody(@_);
        }
    print "</body></html>\n";
    }

}

## theme_error
#
#sub theme_error {

#print "error";

#}


sub chop_font {

if (!$current_lang_info->{'titles'} || $gconfig{'texttitles'}) {
	print $t;
} else {
        foreach $l (split(//, $t)) {
            $ll = ord($l);
	    local $gif;
            if ($ll > 127 && $current_lang_info->{'charset'}) {
		$gif = "$ll.$current_lang_info->{'charset'}.gif";
		}
	    else {
		$gif = "$ll.gif";
		}
            }
	}
}

sub tab_start {
    print qq~    <td>
      <table border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td></td>
          <td nowrap>
          ~;
}


sub tab_end {
     print qq~</td>
          <td nowrap></td>
        </tr>
        <tr>
          <td nowrap></td>
          <td nowrap></td>
          <td nowrap></td></tr>
      </table>

    </td>~;
}

1;

